#include <assert.h>
#include "utils/common.h"
#include "utils/pkcs7.h"
#include <stdio.h>
#include <string.h>
#include "cbc.h"

FUNC(pkcs7_test)
{
    // int pkcs7_pad(const char* i_buff, const size_t i_len, char* o_buff );
    const char text1[] = "Text1";
    const char text2[] = "Text2ToPad";
    int ret;
    char buff1[32];
    char buff2[10];

    ret = pkcs7_pad(text1, 5, buff1, 32);
    check(ret==0, (const unsigned char* const) "Padding operation failed");
    ret = memcmp(text1, buff1, 5);
    check(ret==0, (const unsigned char* const) "Content differs");
    for(int i=5; i<32; i++)
    {
        check(buff1[i] == 27, (const unsigned char* const) "Wrong padding");
    }
}
FUNC_E

FUNC(cbc_decrypt)
{
    uint8_t     iv[16]  = {0};
    char        key[17] = "YELLOW SUBMARINE"; // 16+'\0' = 17
    size_t      len = 0;
    uint8_t     buff[4096] = {0};
    Result_t    res = Result_Error;

    res = load_base64_to_hex("etc/set2_t2.txt", buff, &len);

}
FUNC_E