#include <stdlib.h>
#include <string.h>
#include <stdio.h>

int pkcs7_pad(const char* i_buff, size_t i_len, char* o_buff, size_t i_obuff_len )
{
    if(i_obuff_len < i_len )
    {
        return -1;
    }

    const unsigned pad_value = i_obuff_len - i_len;
    memset(o_buff, pad_value, i_obuff_len);
    memcpy(o_buff, i_buff, i_len);

    return 0;
}